!
      program ex3
!
      use HDF5
      implicit none
!
      character(len=20), parameter :: file_name="RUN/my_3rd_file.h5"
      integer(hid_t) :: file_id       !! file identifier
      integer(hid_t) :: group_id      !! group identifier
      integer(hid_t) :: groupA_id     !! sub-group identifier
      integer(hid_t) :: groupB_id     !! sub-group identifier
      integer        :: hdferr

!
      write(6,*) "writing h5 file ", file_name, "with 3 groups"
!
! open the fortran interface for hdf5   
      call h5open_f(hdferr);

! create the file using default properties.
      call h5fcreate_f(file_name, H5F_ACC_TRUNC_F, file_id, hdferr, &
                       H5P_DEFAULT_F, H5P_DEFAULT_F)

! create a group named "/MyGroup" in the file. */
      call h5gcreate_f(file_id, "MyGroup", group_id, hdferr, &
                       OBJECT_NAMELEN_DEFAULT_F, H5P_DEFAULT_F, &
                       H5P_DEFAULT_F, H5P_DEFAULT_F)

! create sub-group "Group_A" in group "MyGroup" using absolute name. */
      call h5gcreate_f(file_id, "MyGroup/Group_A", groupA_id, hdferr, &
                       OBJECT_NAMELEN_DEFAULT_F, H5P_DEFAULT_F, &
                       H5P_DEFAULT_F, H5P_DEFAULT_F)

! create sub group "Group_B" in group "MyGroup" using relative name. */
      call h5gcreate_f(group_id, "Group_B", groupB_id, hdferr, &
                       OBJECT_NAMELEN_DEFAULT_F, H5P_DEFAULT_F, &
                       H5P_DEFAULT_F, H5P_DEFAULT_F)

! close the group
      call h5gclose_f(group_id, hdferr)
      call h5gclose_f(groupA_id, hdferr)
      call h5gclose_f(groupB_id, hdferr)

! close the file
      call h5fclose_f(file_id, hdferr)

! close the interface
      call h5close_f(hdferr)
      write(6,*) ".... done"

      end program ex3
