#include <hdf5.h>
int main() {
char H5FILE_NAME[128];
hid_t file_id;            /* file identifier */
hid_t dataspace_id;       /* dataspace identifier */
hid_t dataset_id;         /* dataset identifier */
hid_t memspace_id;	  /* memspace identifier */

int i, j;
int sub_data[2][4];

hsize_t dim_sub[2];
hsize_t start[2]; 
hsize_t count[2];

herr_t status;

/* filename */
sprintf(H5FILE_NAME,"RUN/%s.h5","my_fourth_file");
printf("opening h5 file: %s ...",H5FILE_NAME);
printf("...and modify a part of dataspace...");

/* Create the dataspace for the subset of data */
dim_sub[0] = 2;
dim_sub[1] = 4;
memspace_id = H5Screate_simple (2,dim_sub,NULL);

/* open an existing file */
file_id = H5Fopen (H5FILE_NAME,H5F_ACC_RDWR,H5P_DEFAULT);

/* open an existing dataset */
dataset_id = H5Dopen (file_id,"dset",H5P_DEFAULT);

/* Selection, in the dataspace of the dataset,
   of the hyperslab where write the new subset of data */
dataspace_id = H5Dget_space (dataset_id);

start[0] = 1; 
start[1] = 1;
count[0] = dim_sub[0] ; 
count[1] = dim_sub[1];

status = H5Sselect_hyperslab (dataspace_id, H5S_SELECT_SET, start, NULL,
            count, NULL);

/* Initialization of data to be written */
for (i=0; i<dim_sub[0]; i++){
   for (j=0; j<dim_sub[1]; j++){
       sub_data[i][j]=1000+i*dim_sub[1]+j;
   }
}

/* Write hyperslab to dataset */
status = H5Dwrite (dataset_id, H5T_NATIVE_INT, memspace_id, dataspace_id, H5P_DEFAULT, sub_data);

/* close dataset and dataspace */
status = H5Dclose (dataset_id); 
status = H5Sclose (dataspace_id);
status = H5Sclose (memspace_id);

/* Terminate access to the file. */
status = H5Fclose (file_id);

printf("...done\n");
}
