!
      program ex6
!
      use HDF5
      implicit none
!
      character(len=20), parameter :: file_name="RUN/my_4th_file.h5"
      integer(hid_t) :: file_id       !! file identifier
      integer(hid_t) :: group_id      !! group identifier
      integer(hid_t) :: groupA_id     !! sub-group identifier
      integer(hid_t) :: groupB_id     !! sub-group identifier
      integer(hid_t) :: dataset_id    !! dasaset identifier
      integer(hid_t) :: dataspace_id  !! dataspace identifier
      integer(hid_t) :: memspace_id   !! memorispace identifier
      integer(hid_t) :: dc_pl         !! property list
      integer(hsize_t) :: dims_sub(2)
      integer(hsize_t) :: start(2), count(2), stride(2), block(2)
      integer        :: hdferr
      integer        :: i,j 
      integer        :: dset_data(2,4)
!
! set size...
      dims_sub(1) = 2
      dims_sub(2) = 4
!
! set offset et al...
      start(1)  = 1
      start(2)  = 1
      count(1)  = dims_sub(1)
      count(2)  = dims_sub(2)
!
! set dset_data
      do j = 1, dims_sub(2)
         do i = 1, dims_sub(1)
            dset_data(i,j) = -100+(j-1)*dims_sub(1)+i 
         enddo
      enddo
!
      write(6,*) "opening ", file_name, " and modify a part of dataset"
!
! open the fortran interface for hdf5   
      call h5open_f(hdferr);

! create the dataspace for the subset of data
      call h5screate_simple_f(2, dims_sub, memspace_id, hdferr, dims_sub)

! opening an exisiting file...
      call h5fopen_f(file_name, H5F_ACC_RDWR_F, file_id, hdferr, &
                     H5P_DEFAULT_F)

! open an existing dataset 
      call h5dopen_f(file_id, "dset", dataset_id, &
                     hdferr, H5P_DEFAULT_F)
!
! Selection, in the dataspace of the dataset, of the hyperslab 
! where write the new subset of data 
      call h5dget_space_f(dataset_id, dataspace_id, hdferr)
      call h5sselect_hyperslab_f(dataspace_id, H5S_SELECT_SET_F, &
                    start, count, hdferr)

! write hyperslab to dataset */
      call h5dwrite_f(dataset_id, H5T_NATIVE_INTEGER, dset_data, dims_sub, &
                    hdferr, memspace_id, dataspace_id, H5P_DEFAULT_F)

! close dataspace & dataset
      call h5dclose_f(dataset_id, hdferr)

! close the file 
      call h5fclose_f(file_id, hdferr)

! close the interface
      call h5close_f(hdferr);

      write(6,*) ".... done"

      end program ex6
