#include <hdf5.h>
int main() {
char H5FILE_NAME[128];
hid_t file_id;            /* file identifier */
hid_t dataset_id;         /* dataset identifier */
hid_t attribute_id;       /* attribute identifier */
hid_t dataspace_id;       /* dataspace identifier */
int attr_data[2];
hsize_t dims=2;
herr_t status;

/* Initialize the attribute data */
attr_data[0] = 100;  attr_data[1] = 200;

/* filename */
sprintf(H5FILE_NAME,"RUN/%s.h5","my_fourth_file");
printf("opening h5 file: %s ...",H5FILE_NAME);
printf("...and creating attributes...");

/* open an existing file */
file_id = H5Fopen (H5FILE_NAME,H5F_ACC_RDWR,H5P_DEFAULT);

/* open an existing dataset */
dataset_id = H5Dopen (file_id,"dset",H5P_DEFAULT);

/* Create the dataspace for the attribute */
dataspace_id = H5Screate_simple(1, &dims, NULL);

/* Create a dataset attribute */
attribute_id = H5Acreate(dataset_id,"attr",H5T_NATIVE_INT,dataspace_id,H5P_DEFAULT,H5P_DEFAULT);

/* Write the attribute data */
status = H5Awrite(attribute_id,H5T_NATIVE_INT,attr_data);

/* close dataset et al. */
status = H5Aclose(attribute_id);
status = H5Sclose(dataspace_id);
status = H5Dclose(dataset_id); 

/* Terminate access to the file. */
status = H5Fclose(file_id);
printf("...done\n");
}

